import { ChangeDetectorRef, EventEmitter, Renderer2, AfterViewInit } from '@angular/core';
import { NgForm } from '@angular/forms';
import { StorageService, ApiService } from '@dotgov/core';
import { BuilderTask, BuilderModel } from '../../models/builder.model';
import { BuilderService } from '../../../dnd/services/builder.service';
export declare class FBRendererComponent extends StorageService implements AfterViewInit {
    private ref;
    private renderer;
    private builderService;
    private api;
    loading: boolean;
    selectedTab: any;
    selectedTabIndex: number;
    loadingTemplates: boolean;
    activeSidebarTab: string;
    private _formBuilderHelper;
    private _activeTask;
    private _controlDown;
    private _rendererSubscriptions;
    private _backupModels;
    reset: EventEmitter<boolean>;
    save: EventEmitter<{
        task: any;
        models: any;
    }>;
    formRenderer: NgForm;
    preview: EventEmitter<{
        task: any;
        models: any;
    }>;
    task: BuilderTask;
    templateList: any;
    activeTable: string;
    private _availableModels;
    availableModels: BuilderModel;
    readonly invalidTask: boolean;
    readonly newRow: any[];
    readonly activeDragging: boolean;
    readonly draggedModel: any;
    readonly isTabActive: any;
    constructor(ref: ChangeDetectorRef, renderer: Renderer2, builderService: BuilderService, api: ApiService);
    ngAfterViewInit(): void;
    onDrop(event: any): void;
    onTabDropped(tab: any): void;
    formNameChanged(newName: any): void;
    tabNameChanged(tab: any, tabIndex: number, value: string): void;
    addNewTab(container: any): void;
    isActive(tab: any, tabIndex?: number): boolean;
    removeTabHandler(tab: any, container: any, index: number): void;
    move(container: any, tabIndex: any, direction: any): void;
    addTemplate(template: any, type?: string): void;
    templateDelete({template, type}: {
        template: any;
        type: any;
    }): void;
    resetAll(): void;
    saveAll(preview?: boolean): void;
    exportToJson(): void;
    importFromJson(): void;
    uploadAsTemplate(tab: any): void;
    private download(filename, text);
    private documentKeydown(event);
    private documentKeyup();
    private updateTabNamingHTML();
    private loadTemplates(table);
}
